// spacetravel_screensaver.c
// 3DGS 100-lines-contest / 2008
// 
// author: u.seiffert
// version A7 lite-c 7.07.6
// textures are from http://hubblesite.org/copyright/ and free to use for nuncommercial purposes
// music made and copyright by u.seiffert / gameus
// ! exit by mousemove or key_any !
// ---------------------------------------------------------------------------------------------
#include <acknex.h>
#include <default.c>

#define	gc_speed	3										// travelspeed

var gv_sin = 0;											// internal use (sinus)

// automusic
TEXT* 	txt_randtitle = {strings=1000;}
STRING*	str_randmus_track 		= "#255";		// (info) title of the currently played track
var	gv_randmus_playing			= 0;				// (info) "1" if track is playing
var	gv_randmus_tracks				= 0;				// (info) number of available tracks
var	gv_randmusvec_setolume		= 100;			// (internal) the volume (use set_random_musicvec_setol)
var	hdl_random_music;									// (internal) handle to track

//-------------------------------------------------------------------------------------------
// startup - get all mp3-title from the app dir
void random_music_startup(){	
	txt_for_dir(txt_randtitle, "*.mp3");
	gv_randmus_tracks=0;
	while(str_len((txt_randtitle.pstring)[gv_randmus_tracks])>0){gv_randmus_tracks++;}
}
//-------------------------------------------------------------------------------------------
// start playing
function random_music_start(){

	// no title or already playing!
	if(gv_randmus_tracks==0 || media_playing(hdl_random_music)){return(-1);}
	
	// start
	gv_randmus_playing=1;	
	
	// set vol to 100
	if(gv_randmusvec_setolume==0){gv_randmusvec_setolume=100;}
	
	while(gv_randmus_playing==1){	
		// play new random title
		if(!media_playing(hdl_random_music)){
			str_cpy(str_randmus_track, (txt_randtitle.pstring)[integer(random(gv_randmus_tracks))]);	// title			
			hdl_random_music=media_play(str_randmus_track, NULL, gv_randmusvec_setolume);			
		}		
		wait(1);	
	}
}
//--------------------------------------------------------------------------------------------
PANEL* pan_logo = {	
	bmap="logo.tga";
	flags=visible;
}
//--------------------------------------------------------------------------------------
// lines from the 3dgs-templates-shader
function mtl_uvspeed_render(){
   my.u = (my.skill1+total_ticks)*gc_speed;
   my.v = (my.skill2+total_ticks);
}
//--------------------------------------------------------------------------------------
function mtl_uvspeed_init(){
	mtl.event = mtl_uvspeed_render;
	set(mtl,ENABLE_RENDER);
}
//--------------------------------------------------------------------------------------
MATERIAL* mtl_uvspeed = {
	event = mtl_uvspeed_init;
}
//--------------------------------------------------------------------------------------
function eff_a_spec_fun(PARTICLE* p){
    p.alpha += random(1)*time_step;
    p.lifespan = (p.alpha < 80);
}
//--------------------------------------------------------------------------------------
function eff_aspezial(PARTICLE* p){
    vec_set(p.blue, vector(100, 100, 100));
    vec_set(p.vel_x, vector(random(6) - 3, random(6) - 3, 5+random(20)));
    p.size = .1+random(1);
    p.alpha = 15;    
    set(p, BRIGHT|BEAM|MOVE|TRANSLUCENT);
    p.event = eff_a_spec_fun;
}
//--------------------------------------------------------------------------------------
action act_rotate(){
	
	wait(1);
	my.material=mtl_uvspeed;
	
	while(my.skill1>0){
		// color
		vec_set(mtl_uvspeed.ambient_blue, vector(gv_sin*my.skill3*10, 20, -gv_sin*my.skill3*10));
		vec_set(mtl_uvspeed.emissive_blue, vector(-gv_sin*my.skill3*50+10, gv_sin*my.skill3*50+10, gv_sin*my.skill3*50+60));
		
		// skinshift
		my.skill1=gc_speed+gv_sin*0.1;
		my.skill2=gv_sin*my.skill3*0.2;
		
		// camera distortion
		camera.arc=50+gv_sin*10;
		camera.pan+=time_step*0.1;
		wait(1);
	}
	
}
//--------------------------------------------------------------------------------------
void main(){
var lv_cnt = 0, lv_scnt = 0;	

	randomize();
	wait(1);	
	video_set(1024,768,32,1);
	level_load(NULL);
	
	vec_set(sky_color, vector(1,1,1));	
	vec_set(camera.x, vector(0,0,800));
	vec_set(camera.pan, vector(0,270,0));
	camera.arc=50;
	
	// start music...
	random_music_start();
	
	// aussenhlle	
	ent_create("pipe_hull.mdl", nullvector, NULL);
	
	// rotationshllen
	you=ent_create("pipe_blue.mdl", nullvector, act_rotate);
	you.skill1=0;you.skill2=-2;you.skill4=10;
	
	you=ent_create("pipe1.mdl", nullvector, act_rotate);
	you.skill1=5;you.skill2=-.5;you.skill3=-.5;

	you=ent_create("pipe2.mdl", nullvector, act_rotate);
	you.skill1=5;you.skill2=-1;you.skill3=-1;
	
	you=ent_create("pipe3.mdl", nullvector, act_rotate);
	you.skill1=5;you.skill2=-200;you.skill3=1;

	// logo
	pan_logo.pos_x=screen_size.x-bmap_width(pan_logo.bmap);
	pan_logo.pos_y=screen_size.y-bmap_height(pan_logo.bmap);	
	
	while(!mouse_moving && !key_any){
		// global sin		
		lv_scnt=(lv_scnt+time_step)%360;
		gv_sin=sin(lv_scnt);
		
		lv_cnt+=time_step;
		if(lv_cnt>2){
			effect(eff_aspezial, 1, nullvector, nullvector);
			lv_cnt=0;
		}
		wait(1);
	}	
	sys_exit(NULL);	
}
